## simgear 2020.3.19+dfsg

=== simgear/bucket/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS newbucket.hxx)
set(SOURCES newbucket.cxx)

simgear_component(bucket bucket "${SOURCES}" "${HEADERS}")


if(ENABLE_TESTS)

add_executable(test_bucket test_bucket.cxx)
add_test(test_bucket ${EXECUTABLE_OUTPUT_PATH}/test_bucket)
target_link_libraries(test_bucket ${TEST_LIBS})

endif(ENABLE_TESTS)

=== simgear/embedded_resources/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS EmbeddedResource.hxx
            EmbeddedResourceManager.hxx
            EmbeddedResourceProxy.hxx)
set(SOURCES EmbeddedResource.cxx
            EmbeddedResourceManager.cxx
            EmbeddedResourceProxy.cxx)

simgear_component(embedded_resources embedded_resources
                  "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)
    add_executable(test_embedded_resources embedded_resources_test.cxx)
    target_link_libraries(test_embedded_resources ${TEST_LIBS})
    add_test(embedded_resources
             ${EXECUTABLE_OUTPUT_PATH}/test_embedded_resources)
endif(ENABLE_TESTS)

=== simgear/math/CMakeLists.txt ===
include (SimGearComponent)


set(HEADERS
    SGBox.hxx
    SGCMath.hxx
    SGGeoc.hxx
    SGGeod.hxx
    SGGeodesy.hxx
    SGGeometry.hxx
    SGGeometryFwd.hxx
    SGIntersect.hxx
    SGLimits.hxx
    SGLineSegment.hxx
    SGLocation.hxx
    SGMath.hxx
    SGMathFwd.hxx
    SGMatrix.hxx
    SGMisc.hxx
    SGPlane.hxx
    SGQuat.hxx
    SGRay.hxx
    SGRect.hxx
    SGSphere.hxx
    SGTriangle.hxx
    SGVec2.hxx
    SGVec3.hxx
    SGVec4.hxx
    beziercurve.hxx
    interpolater.hxx
    leastsqs.hxx
    sg_geodesy.hxx
    sg_types.hxx
    sg_random.h
    simd.hxx
    simd4x4.hxx
    )

set(SOURCES 
    SGGeodesy.cxx
    interpolater.cxx
    leastsqs.cxx
    sg_random.c
    )

simgear_component(math math "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

add_executable(sgvec4_test test_sgvec4.cxx)
target_link_libraries(sgvec4_test ${TEST_LIBS})
add_test(sgvec4 ${EXECUTABLE_OUTPUT_PATH}/sgvec4_test)

add_executable(math_test SGMathTest.cxx)
target_link_libraries(math_test ${TEST_LIBS})
add_test(math ${EXECUTABLE_OUTPUT_PATH}/math_test)

add_executable(geometry_test SGGeometryTest.cxx)
target_link_libraries(geometry_test ${TEST_LIBS})
add_test(geometry ${EXECUTABLE_OUTPUT_PATH}/geometry_test)

endif(ENABLE_TESTS)

=== simgear/serial/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS serial.hxx)
set(SOURCES serial.cxx)

simgear_component(serial serial "${SOURCES}" "${HEADERS}")

=== simgear/io/iostreams/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS
    sgstream.hxx
    gzfstream.hxx
    gzcontainerfile.hxx
    CharArrayStream.hxx
    zlibstream.hxx
    )

set(SOURCES
    sgstream.cxx
    gzfstream.cxx
    gzcontainerfile.cxx
    CharArrayStream.cxx
    zlibstream.cxx
    )

simgear_component(IOStreams io/iostreams "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

  add_executable(test_streams sgstream_test.cxx )
  target_link_libraries(test_streams ${TEST_LIBS})
  add_test(streams ${EXECUTABLE_OUTPUT_PATH}/test_streams)

  add_executable(test_CharArrayStream CharArrayStream_test.cxx)
  target_link_libraries(test_CharArrayStream ${TEST_LIBS})
  add_test(CharArrayStream ${EXECUTABLE_OUTPUT_PATH}/test_CharArrayStream)

  add_executable(test_zlibstream zlibstream_test.cxx)
  target_link_libraries(test_zlibstream ${TEST_LIBS})
  add_test(zlibstream ${EXECUTABLE_OUTPUT_PATH}/test_zlibstream)

endif(ENABLE_TESTS)

=== simgear/scene/model/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS 
    BoundingVolumeBuildVisitor.hxx
    BVHDebugCollectVisitor.hxx
    BVHPageNodeOSG.hxx
    CheckSceneryVisitor.hxx
    ConditionNode.hxx
    ModelRegistry.hxx
    PrimitiveCollector.hxx
    SGClipGroup.hxx
    SGInteractionAnimation.hxx
    SGLight.hxx
    SGMaterialAnimation.hxx
    SGPickAnimation.hxx
    SGOffsetTransform.hxx
    SGReaderWriterXML.hxx
    SGRotateTransform.hxx
    SGScaleTransform.hxx
    SGText.hxx
    SGTrackToAnimation.hxx
    SGTranslateTransform.hxx
    animation.hxx
    model.hxx
    modellib.hxx
    particles.hxx
    persparam.hxx
    placement.hxx
    )

set(SOURCES 
    BVHPageNodeOSG.cxx
    CheckSceneryVisitor.cxx
    ConditionNode.cxx
    ModelRegistry.cxx
    PrimitiveCollector.cxx
    SGClipGroup.cxx
    SGInteractionAnimation.cxx
    SGLight.cxx
    SGLightAnimation.cxx
    SGPickAnimation.cxx
    SGMaterialAnimation.cxx
    SGOffsetTransform.cxx
    SGReaderWriterXML.cxx
    SGRotateTransform.cxx
    SGScaleTransform.cxx
    SGText.cxx
    SGTrackToAnimation.cxx
    SGTranslateTransform.cxx
    animation.cxx
    model.cxx
    modellib.cxx
    particles.cxx
    persparam.cxx
    placement.cxx    
    shadanim.cxx
    )

simgear_scene_component(model scene/model "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

  add_executable(test_animations animation_test.cxx)
  target_link_libraries(test_animations ${TEST_LIBS} ${OPENSCENEGRAPH_LIBRARIES})
  add_test(animations ${EXECUTABLE_OUTPUT_PATH}/test_animations)

endif(ENABLE_TESTS)

=== debian/changelog ===
simgear (1:2020.3.19+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Dmitry Shachnev ]
  * Backport upstream fixes for Boost 1.88 (closes: #1125271).

  [ Dr. Tobias Quathamer ]
  * Update d/watch to version 5
  * Remove Rules-Requires-Root from d/control
  * Update homepage
  * Remove Priority: optional from d/control
  * Update Standards-Version to 4.7.3

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 15 Jan 2026 16:47:44 +0100

simgear (1:2020.3.19+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113503)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 14:10:57 +0200

simgear (1:2020.3.19+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2020.3.19+dfsg
    - New patch: check I/O rules when auto-constructing an SGPath from
      a Nasal scalar. Thanks to Florent Rougon <f.rougon@frougon.net>
      (CVE-2025-0781)
  * Update Standards-Version to 4.7.0, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 26 Jan 2025 01:03:37 +0100

=== debian/control ===
Source: simgear
Section: libs
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
           Markus Wanner <markus@bluegap.ch>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-dev,
               libcurl4-gnutls-dev,
               libexpat1-dev,
               libgl-dev,
               libglu1-mesa-dev,
               liblzma-dev,
               libopenal-dev,
               libopenscenegraph-dev,
               libudns-dev,
               libutfcpp-dev,
               netbase,
               zlib1g-dev
Standards-Version: 4.7.3
Homepage: https://www.flightgear.org/
Vcs-Browser: https://salsa.debian.org/debian/simgear
Vcs-Git: https://salsa.debian.org/debian/simgear.git

Package: libsimgear-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libc6-dev,
         libopenscenegraph-dev,
         ${misc:Depends}
Description: Simulator Construction Gear -- development files
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the headers and static libraries.

=== debian/watch ===
Version: 5
Source: https://gitlab.com/api/v4/projects/flightgear%2F@PACKAGE@/repository/tags
Matching-Pattern: https://gitlab.com/flightgear/@PACKAGE@/.*/@PACKAGE@-v?@STABLE_VERSION@@ARCHIVE_EXT@
Pagemangle: s!"name":"(v?@ANY_VERSION@)"!<a href="https://gitlab.com/flightgear/@PACKAGE@/-/archive/$1/@PACKAGE@-$1.tar.bz2">!g
Dversion-Mangle: auto
Repack-Suffix: +dfsg

## simgear 2024.1.3+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

if(POLICY CMP0072)
  cmake_policy(SET CMP0072 NEW)
endif()

if(POLICY CMP0093)
  cmake_policy(SET CMP0093 NEW)
endif()

if(POLICY CMP0145)
  cmake_policy(SET CMP0145 NEW)
endif()

if(POLICY CMP0167)
  cmake_policy(SET CMP0167 NEW)
endif()

message(STATUS "CMAKE Build type: ${CMAKE_BUILD_TYPE}")
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

include (CheckFunctionExists)
include (CheckIncludeFile)
include (CheckLibraryExists)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)
include (GenerateExportHeader)

# only relevant for building shared libs but let's set it regardless
set(CMAKE_OSX_RPATH 1)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ simgear-version versionFile)
string(STRIP ${versionFile} SIMGEAR_VERSION)

project(SimGear VERSION ${SIMGEAR_VERSION} LANGUAGES C CXX)

# add a dependency on the version file
set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS version)

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# use simgear version also as the SO version (if building SOs)
SET(SIMGEAR_SOVERSION ${SIMGEAR_VERSION})

# Warning when build is not an out-of-source build.
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" InSourceBuild)
if(InSourceBuild)
    message(WARNING  "Avoid building inside the source tree!")
    message(WARNING  "Create a separate build directory instead (i.e. 'sgbuild') and call CMake from there: ")
    message(WARNING  "  mkdir ../sgbuild && cd ../sgbuild && cmake ${CMAKE_SOURCE_DIR}")
endif(InSourceBuild)


# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

include(Packaging)

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# Determine name of library installation directory, i.e. "lib" vs "lib64", which
# differs between all Debian-based vs all other Linux distros.
# See cmake bug #11964, http://cmake.org/gitweb?p=cmake.git;a=commit;h=126c993d
include(GNUInstallDirs)
message(STATUS "Library installation directory: ${CMAKE_INSTALL_LIBDIR}")

#####################################################################################
# Configure library search paths
#####################################################################################

if (NOT MSVC)
option(SIMGEAR_SHARED   "Set to ON to build SimGear as a shared library/framework" OFF)
option(SYSTEM_EXPAT     "Set to ON to build SimGear using the system expat library" OFF)
option(SYSTEM_UDNS      "Set to ON to build SimGear using the system udns library" OFF)
else()
# Building SimGear DLLs is currently not supported for MSVC.
set(SIMGEAR_SHARED OFF)
# Using external 3rd party libraries is currently not supported for MSVC - it would require shared simgear (DLL).
set(SYSTEM_EXPAT OFF)
set(SYSTEM_UDNS OFF)
endif()

option(SIMGEAR_HEADLESS "Set to ON to build SimGear without GUI/graphics support" OFF)
option(ENABLE_CYCLONE   "Set to ON to build SimGear with Cyclone Data Distribution Service support" ON)
option(ENABLE_RTI       "Set to ON to build SimGear with RTI support" OFF)
option(ENABLE_GDAL      "Set to ON to build SimGear with GDAL support" OFF)
option(ENABLE_TESTS     "Set to OFF to disable building SimGear's test applications" ON)
option(ENABLE_SOUND     "Set to OFF to disable building SimGear's sound support" ON)
option(USE_AEONWAVE     "Set to ON to use AeonWave instead of OpenAL" ON)
option(USE_OPENALSOFT   "Set to ON to use OpenAL from OpenAL-soft" OFF)

option(ENABLE_PKGUTIL   "Set to ON to build the sg_pkgutil application (default)" ON)
option(ENABLE_SIMD      "Enable SSE/SSE2 support for compilers" ON)
option(ENABLE_ASAN      "Set to ON to build SimGear with LLVM AddressSanitizer (ASan) support.  Incompatile with ENABLE_TSAN." OFF)
option(ENABLE_TSAN      "Set to ON to build SimGear with LLVM ThreadSanitizer (TSan) support. Incompatile with ENABLE_ASAN." OFF)
option(ENABLE_VIDEO_RECORD "Set to ON to build SimGear with video recording" ON)

set(OPENVG ShivaVG)
message(STATUS "OpenVG: ${OPENVG}")

include (DetectArch)
include (ExportDebugSymbols)

# until the fstream fix is applied and generally available in OSG,
# keep the compatibility link option as the default
option(OSG_FSTREAM_EXPORT_FIXED "Set to ON if the osgDB fstream export patch is applied" OFF)

if (MSVC)
  # override CMake default RelWithDebInfo flags. This is important to ensure
  # good performance
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "/Zi /O2 /Ob2 /D NDEBUG")
  set(CMAKE_C_FLAGS_RELWITHDEBINFO "/Zi /O2 /Ob2 /D NDEBUG")
endif ()

# Setup MSVC 3rd party directories
include( ConfigureMsvc3rdParty )

if(APPLE)
  find_library(COCOA_LIBRARY Cocoa)
  add_compile_definitions(GL_SILENCE_DEPRECATION)
endif()

find_package(Threads REQUIRED)

find_package(Boost REQUIRED)
set (BOOST_CXX_FLAGS "-DBOOST_BIMAP_DISABLE_SERIALIZATION -DBOOST_NO_STDLIB_CONFIG -DBOOST_NO_AUTO_PTR -DBOOST_NO_CXX98_BINDERS")
include(BoostTestTargets)

set(SG_SOUND_USES_OPENALSOFT OFF) # default to off

if(SIMGEAR_HEADLESS)
    message(STATUS "SimGear mode: HEADLESS")
    set(ENABLE_SOUND 0)
else()
    message(STATUS "SimGear mode: NORMAL")
    find_package(OpenGL REQUIRED)

    if (ENABLE_SOUND)
        if (USE_AEONWAVE)
            find_package(AAX)
        endif()

        if(NOT AAX_FOUND)
            set(USE_AEONWAVE FALSE)
            if (USE_OPENALSOFT)
                message(STATUS "Sound requested to use OpenAL-soft: ensure Config.cmake files are in CMAKE_PREFIX_PATH")
               find_package(OpenAL REQUIRED CONFIG)
               if (TARGET OpenAL::OpenAL)
                # set in the cache so superbuild can find the value
                set(SG_SOUND_USES_OPENALSOFT ON CACHE BOOL "True if OpenAL appears to be OpenAL-soft")
               endif()
            else()
              # regular OpenAL is found via the CMake distro-suppling FindOpenAL
              find_package(OpenAL REQUIRED)
            endif()

            message(STATUS "OpenAL: ${OPENAL_LIBRARY}")
        endif()

        if(AAX_FOUND)
            message(STATUS "Sound support: AeonWave")
        elseif (TARGET OpenAL::OpenAL)
           message(STATUS "Sound support: OpenAL-soft")
        else()
            message(STATUS "Sound support: OpenAL (from system)")
        endif()
    endif(ENABLE_SOUND)

    include(CreateOSGImportedTargets)
endif(SIMGEAR_HEADLESS)

if(${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
    # As of 2020-08-01, OpenBSD's system zlib is slightly old, but it's usable
    # with a workaround in simgear/io/iostreams/gzfstream.cxx.
    find_package(ZLIB 1.2.3 REQUIRED)
else()
    find_package(ZLIB 1.2.4 REQUIRED)
endif()

find_package(LibLZMA REQUIRED)
find_package(CURL REQUIRED)

if (SYSTEM_EXPAT)
    message(STATUS "Requested to use system Expat library, forcing SIMGEAR_SHARED to true")
    set(SIMGEAR_SHARED ON)
    find_package(EXPAT REQUIRED)

else()
    message(STATUS "Using built-in expat code")
endif(SYSTEM_EXPAT)

if(ENABLE_RTI)
    find_package(PkgConfig)
    if(PKG_CONFIG_FOUND)
      SET(ENV{PKG_CONFIG_PATH} "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig:$ENV{PKG_CONFIG_PATH}")
      pkg_check_modules(RTI IMPORTED_TARGET hla-rti13)
    endif(PKG_CONFIG_FOUND)
    if(RTI_FOUND)
      message(STATUS "RTI: ENABLED")
    else()
      message(STATUS "RTI: DISABLED")
    endif(RTI_FOUND)
else()
    message(STATUS "RTI: DISABLED")
endif(ENABLE_RTI)

if(ENABLE_CYCLONE)
    find_package(CycloneDDS QUIET)
    if (CycloneDDS_FOUND)
        message(STATUS "Data Distribution Service support: CycloneDDS")
        set(SG_HAVE_DDS 1)
    else(CycloneDDS_FOUND)
        message(STATUS "Data Distribution Service support: DISABLED")
    endif(CycloneDDS_FOUND)
endif(ENABLE_CYCLONE)

if(ENABLE_GDAL)
    find_package(GDAL 2.0.0 REQUIRED)
endif(ENABLE_GDAL)


if (ENABLE_VIDEO_RECORD)
  find_package(FFmpeg COMPONENTS AVCODEC AVFORMAT AVUTIL SWSCALE)
  if (FFmpeg_FOUND)
  # set this so it's picked up in simgear_config.h
    set(SG_FFMPEG 1)
    set(SIMGEAR_USE_FFMPEG ON)
    include(CreateFFmpegImportedTargets)
    message(STATUS "FFmpeg found, Video recording enabled")
  else()
    message(STATUS "Video recording was requested, but required FFmpeg/avcodec libraries not found")
  endif()
endif()

find_package(c-ares 1.27)
if(c-ares_FOUND)
    # needed for SimGearConfig.cmaake generation
    set(SIMGEAR_USING_CARES_DNS 1)

    message(STATUS "Found c-ares, not using UDNS")
else()
  message(STATUS "NOT found c-ares, using UDNS, unit-tests disabled. Expect missing terrasync sources.")
  set(SIMGEAR_USING_CARES_DNS 0)

  if(SYSTEM_UDNS)
      message(STATUS "Requested to use system udns library, forcing SIMGEAR_SHARED to true")
      set(SIMGEAR_SHARED ON)
      find_package(Udns REQUIRED)
  endif()
endif()

include(CheckPOSIXFeatures)

SET(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "add a postfix, usually 'd' on windows")
SET(CMAKE_RELEASE_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")
SET(CMAKE_RELWITHDEBINFO_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")
SET(CMAKE_MINSIZEREL_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")

# Check if the <regex> implementation in the C++ standard library is usable.
# This is necessary because g++ 4.8 lies about its C++11 compliance: its
# <regex> is utterly unusable, cf. [1].
# The big preprocessor test essentially comes from [2], and gcc upstream devs
# appear to back it (see comments following [2], as well as [3]).
#
#   [1] https://stackoverflow.com/a/12665408/4756009
#   [2] https://stackoverflow.com/a/41186162/4756009
#   [3] https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78905
check_cxx_source_compiles(
    "#include <regex>

     int main() {
       #if __cplusplus >= 201103L &&                             \
           (!defined(__GLIBCXX__)                         ||     \
            (__cplusplus >= 201402L)                      ||     \
            defined(_GLIBCXX_REGEX_DFS_QUANTIFIERS_LIMIT) ||     \
            defined(_GLIBCXX_REGEX_STATE_LIMIT)           ||     \
            (defined(_GLIBCXX_RELEASE) && _GLIBCXX_RELEASE > 4))
       #else
         nullptr = void; // intentionally trigger a compilation error
       #endif
     }"
    HAVE_WORKING_STD_REGEX)

if(CMAKE_COMPILER_IS_GNUCXX)
    set(WARNING_FLAGS_CXX "-Wall -fPIC")
    set(WARNING_FLAGS_C   "-Wall -fPIC")

    if (X86 OR X86_64)
        set(SIMD_COMPILER_FLAGS "-msse2 -mfpmath=sse -ftree-vectorize -ftree-slp-vectorize")
    endif()

    # certain GCC versions don't provide the atomic builds, and hence
    # require is to provide them in SGAtomic.cxx
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_INCLUDE_PATH})
    check_cxx_source_compiles(
       "int main() { unsigned mValue; return __sync_add_and_fetch(&mValue, 1); }"
        GCC_ATOMIC_BUILTINS_FOUND)

    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O3 -g -DNDEBUG")
    set(CMAKE_C_FLAGS_RELWITHDEBINFO  "-O3 -g -DNDEBUG")
endif(CMAKE_COMPILER_IS_GNUCXX)

if (CLANG)
    message(STATUS "CMAKE_OSX_ARCHITECTURES has value: ${CMAKE_OSX_ARCHITECTURES}")

    # Boost redeclares class members
    # OSG doesn't use override but we subclass from it, so we will

=== debian/changelog ===
simgear (1:2024.1.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2024.1.3+dfsg
    - Remove patches which have been applied upstream
    - Refresh patches
    - Add new patch to use system library tinyGLTF
    - Add new patch to add EXPAT as dependency to simgear library
    - Add new build dependencies
  * Use wrap-and-sort -astkb

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 16 Jan 2026 23:54:18 +0100

## simgear 2024.1.4+dfsg

=== simgear/CMakeLists.txt ===

file(WRITE ${PROJECT_BINARY_DIR}/simgear/version.h "#define SIMGEAR_VERSION ${SIMGEAR_VERSION}")

foreach( mylibfolder
        bucket
        debug
        embedded_resources
        emesary
        ephemeris
        io
        magvar
        math
        misc
        nasal
        nasal/cppbind
        props
        serial
        std
        structure
        threads
        timing
        xml
        package
    )

    add_subdirectory(${mylibfolder})

endforeach( mylibfolder )

if(NOT SIMGEAR_HEADLESS)
    add_subdirectory(bvh)
    add_subdirectory(canvas)
    add_subdirectory(environment)
    add_subdirectory(screen)
    add_subdirectory(scene)
    add_subdirectory(sound)
endif(NOT SIMGEAR_HEADLESS)


if(ENABLE_RTI)
    add_subdirectory(hla)
endif(ENABLE_RTI)


set(HEADERS compiler.h constants.h sg_inlines.h ${PROJECT_BINARY_DIR}/simgear/version.h)
install (FILES ${HEADERS}  DESTINATION include/simgear/)

get_property(coreSources GLOBAL PROPERTY CORE_SOURCES)
get_property(sceneSources GLOBAL PROPERTY SCENE_SOURCES)
get_property(publicHeaders GLOBAL PROPERTY PUBLIC_HEADERS)

if(SIMGEAR_SHARED)
    message(STATUS "Library building mode: SHARED LIBRARIES")
    add_library(SimGearCore SHARED ${coreSources} ${localExpatSources})

    set_property(TARGET SimGearCore PROPERTY LINKER_LANGUAGE CXX)
    set_property(TARGET SimGearCore PROPERTY VERSION   ${SIMGEAR_VERSION})
    set_property(TARGET SimGearCore PROPERTY SOVERSION ${SIMGEAR_SOVERSION})


    if(NOT SIMGEAR_HEADLESS)
        add_library(SimGearScene SHARED ${sceneSources})
        set_property(TARGET SimGearScene PROPERTY LINKER_LANGUAGE CXX)
        set_property(TARGET SimGearScene PROPERTY VERSION   ${SIMGEAR_VERSION})
        set_property(TARGET SimGearScene PROPERTY SOVERSION ${SIMGEAR_SOVERSION})
    endif()

    export_debug_symbols(SimGearCore)
    export_debug_symbols(SimGearScene)
else()
    message(STATUS "Library building mode: STATIC LIBRARIES")

	get_property(FG_GROUPS_CORE_SOURCES_C GLOBAL PROPERTY FG_GROUPS_CORE_SOURCES_C)
	string(REPLACE "@" ";" groups ${FG_GROUPS_CORE_SOURCES_C} )
	foreach(g ${groups})
		string(REPLACE "#" ";" g2 ${g})
		list(GET g2 0 name)
		list(REMOVE_AT g2 0)
		source_group("${name}\\Sources" FILES ${g2})
	endforeach()

	get_property(FG_GROUPS_CORE_SOURCES_H GLOBAL PROPERTY FG_GROUPS_CORE_SOURCES_H)
	string(REPLACE "@" ";" groups ${FG_GROUPS_CORE_SOURCES_H} )
	foreach(g ${groups})
		string(REPLACE "#" ";" g2 ${g})
		list(GET g2 0 name)
		list(REMOVE_AT g2 0)
		source_group("${name}\\Headers" FILES ${g2})
	endforeach()

    add_library(SimGearCore STATIC ${coreSources})

    if(NOT SIMGEAR_HEADLESS)
		get_property(FG_GROUPS_SCENE_SOURCES_C GLOBAL PROPERTY FG_GROUPS_SCENE_SOURCES_C)
		string(REPLACE "@" ";" groups ${FG_GROUPS_SCENE_SOURCES_C} )
		foreach(g ${groups})
			string(REPLACE "#" ";" g2 ${g})
			list(GET g2 0 name)
			list(REMOVE_AT g2 0)
			source_group("${name}\\Sources" FILES ${g2})
		endforeach()

		get_property(FG_GROUPS_SCENE_SOURCES_H GLOBAL PROPERTY FG_GROUPS_SCENE_SOURCES_H)
		string(REPLACE "@" ";" groups ${FG_GROUPS_SCENE_SOURCES_H} )
		foreach(g ${groups})
			string(REPLACE "#" ";" g2 ${g})
			list(GET g2 0 name)
			list(REMOVE_AT g2 0)
			source_group("${name}\\Headers" FILES ${g2})
		endforeach()

        add_library(SimGearScene STATIC ${sceneSources})
    endif(NOT SIMGEAR_HEADLESS)
endif(SIMGEAR_SHARED)

target_include_directories(SimGearCore BEFORE PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)
        
# for simgear_config.h
target_include_directories(SimGearCore PRIVATE ${PROJECT_BINARY_DIR}/simgear)

# needed for include of <simgear/simgear_config.h> in superbuild
target_include_directories(SimGearCore INTERFACE $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>)

target_include_directories(SimGearCore PUBLIC
  ${Boost_INCLUDE_DIRS})

if (MSVC)
    message(WARNING "FIXME: setting _HAS_STD_BYTE=0 for SimGear build, this needs to be fixed.")
    target_compile_definitions(SimGearCore PRIVATE _HAS_STD_BYTE=0)
endif()

install(TARGETS SimGearCore
        EXPORT SimGearTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

# we expose ZLib in some of our headers
target_link_libraries(SimGearCore PUBLIC ZLIB::ZLIB)

if (SG_HAVE_DDS)
    target_link_libraries(SimGearCore PRIVATE CycloneDDS::ddsc)
endif()

if (ENABLE_RTI)
    target_sources(SimGearCore PRIVATE $<TARGET_OBJECTS:rti> $<TARGET_OBJECTS:rti13>)
    target_link_libraries(SimGearCore PRIVATE PkgConfig::RTI)
endif()

# all of these we keep privately
target_link_libraries(SimGearCore PRIVATE
    ${SHLWAPI_LIBRARY}
    ${RT_LIBRARY}
    ${DL_LIBRARY}
    Threads::Threads
    ${COCOA_LIBRARY}
    CURL::libcurl
    EXPAT::EXPAT
    LibLZMA::LibLZMA
    ${WINSOCK_LIBRARY})

if(TARGET c-ares::cares)
    target_link_libraries(SimGearCore PRIVATE c-ares::cares)
else()
    target_link_libraries(SimGearCore PRIVATE Udns::Udns)
endif()

if(NOT SIMGEAR_HEADLESS)
    target_include_directories(SimGearScene PRIVATE ${PROJECT_SOURCE_DIR}/simgear/canvas/${OPENVG}/include)

    target_link_libraries(SimGearScene PUBLIC
        SimGearCore
        OSG::OSG
        OSG::osgText
        OSG::osgDB
        OSG::osgSim
        OSG::osgGA
        OSG::osgUtil
        OSG::osgTerrain
        OSG::osgParticle
        OSG::osgViewer
    )

    if(HAVE_INTTYPES_H)
        # ShivaVG needs inttypes.h
        target_compile_definitions(SimGearScene PRIVATE HAVE_INTTYPES_H)
    endif()

    target_link_libraries(SimGearScene PRIVATE
        ZLIB::ZLIB
        ${OPENGL_LIBRARY}
        ${JPEG_LIBRARY}
        ${FFMPEG_LIBRARIES}
        FGTinyGLTF)

    if (SIMGEAR_USE_FFMPEG)
        target_link_libraries(SimGearScene PRIVATE FFmpeg::avcodec FFmpeg::avformat FFmpeg::swscale FFmpeg::avutil)
    endif()

    # ToDo: define an ALIAS target for the sound backend, to get
    # rid of this logic here
    if (ENABLE_SOUND)
        if (USE_AEONWAVE)
            target_link_libraries(SimGearScene PRIVATE ${AAX_LIBRARY})
        else()
            target_link_libraries(SimGearScene PRIVATE ${OPENAL_LIBRARY} )
        endif()
    endif()

    if(ENABLE_GDAL)
        # FIXME: should be PRIVATE, but we leak GDAL headers
        # in our own headers :(
        target_link_libraries(SimGearScene PUBLIC GDAL::GDAL)
    endif()

    # only actually needed by canvas/KeyboardEvent.cxx
    target_include_directories(SimGearScene PRIVATE ${PROJECT_SOURCE_DIR}/3rdparty/utf8/source)
    target_include_directories(SimGearScene PRIVATE ${FFMPEG_INCLUDE_DIRS})

    install(TARGETS SimGearScene
        EXPORT SimGearTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

    target_include_directories(SimGearScene BEFORE PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>)

    # for simgear_config.h
    target_include_directories(SimGearScene PRIVATE ${PROJECT_BINARY_DIR}/simgear)
    #target_include_directories(SimGearScene SYSTEM PUBLIC ${OPENSCENEGRAPH_INCLUDE_DIRS})

    if (USE_AEONWAVE)
        target_include_directories(SimGearScene PRIVATE ${AAX_INCLUDE_DIR} )
    else()
        target_include_directories(SimGearScene PRIVATE ${OPENAL_INCLUDE_DIR} )
    endif()
endif()

=== simgear/io/CMakeLists.txt ===
add_subdirectory(iostreams)

include (SimGearComponent)

set(HEADERS
    iochannel.hxx
    lowlevel.hxx
    raw_socket.hxx
    sg_binobj.hxx
    sg_file.hxx
    sg_mmap.hxx
    sg_netBuffer.hxx
    sg_netChannel.hxx
    sg_netChat.hxx
    sg_serial.hxx
    sg_socket.hxx
    sg_socket_udp.hxx
    HTTPClient.hxx
    HTTPFileRequest.hxx
    HTTPMemoryRequest.hxx
    HTTPRequest.hxx
    HTTPRepository.hxx
    untar.hxx
    DNSClient.hxx
    )

set(SOURCES
    iochannel.cxx
    lowlevel.cxx
    raw_socket.cxx
    sg_binobj.cxx
    sg_file.cxx
    sg_mmap.cxx
    sg_netBuffer.cxx
    sg_netChannel.cxx
    sg_netChat.cxx
    sg_serial.cxx
    sg_socket.cxx
    sg_socket_udp.cxx
    HTTPClient.cxx
    HTTPTestApi_private.hxx
    HTTPFileRequest.cxx
    HTTPMemoryRequest.cxx
    HTTPRequest.cxx
    HTTPRepository.cxx
    HTTPRepository_private.hxx
    untar.cxx
    )

if(c-ares_FOUND)
    set(SOURCES ${SOURCES}
        DNSClient_cares.cxx
    )
else()
    set(SOURCES ${SOURCES}
        DNSClient.cxx
    )
endif()



if (CycloneDDS_FOUND)
    set(HEADERS ${HEADERS}
        SGDataDistributionService.hxx
        )
    set(SOURCES ${SOURCES}
        SGDataDistributionService.cxx
        )
    add_simgear_test(test_dds test_dds.cxx)
    target_link_libraries(test_dds CycloneDDS::ddsc)
endif (CycloneDDS_FOUND)

simgear_component(io io "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

add_simgear_test(test_sock socktest.cxx)
add_simgear_autotest(test_http test_HTTP.cxx)
if(c-ares_FOUND)
    add_simgear_autotest(test_dns test_DNS.cxx)
endif()
add_simgear_test(httpget httpget.cxx)
add_simgear_test(http_repo_sync http_repo_sync.cxx)
add_simgear_test(decode_binobj decode_binobj.cxx)
add_simgear_autotest(test_binobj test_binobj.cxx)
add_simgear_autotest(test_repository test_repository.cxx)


add_simgear_autotest(test_untar test_untar.cxx)
set_target_properties(test_untar PROPERTIES
  COMPILE_DEFINITIONS "SRC_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"" )

add_simgear_autotest(test_mmap test_mmap.cxx)
set_target_properties(test_mmap PROPERTIES
  COMPILE_DEFINITIONS "SRC_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"" )

endif(ENABLE_TESTS)

=== debian/changelog ===
simgear (1:2024.1.4+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2024.1.4+dfsg
    - Refresh patches

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 30 Jan 2026 16:15:51 +0100

=== debian/control ===
Source: simgear
Section: libs
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders:
 Ove Kaaven <ovek@arcticnet.no>,
 Markus Wanner <markus@bluegap.ch>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libc-ares-dev,
 libcurl4-gnutls-dev,
 libexpat1-dev,
 libgl-dev,
 libglu1-mesa-dev,
 liblzma-dev,
 libopenal-dev,
 libopenscenegraph-dev,
 libtinygltf-dev,
 libudns-dev,
 libutfcpp-dev,
 netbase,
 nlohmann-json3-dev,
 zlib1g-dev,
Standards-Version: 4.7.3
Homepage: https://www.flightgear.org/
Vcs-Browser: https://salsa.debian.org/debian/simgear
Vcs-Git: https://salsa.debian.org/debian/simgear.git

Package: libsimgear-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libc6-dev,
 libopenscenegraph-dev,
 ${misc:Depends},
Description: Simulator Construction Gear -- development files
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the headers and static libraries.
